"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _ProcessDataTracker_chunkStore, _ProcessDataTracker_writeable, _ProcessDataTracker_emitter;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProcessDataTracker = void 0;
const abstract_1 = require("./abstract");
const stream_1 = require("stream");
var Events;
(function (Events) {
    Events["Block"] = "block";
    Events["Unblock"] = "unblock";
})(Events || (Events = {}));
class ProcessDataTracker extends abstract_1.DataTracker {
    constructor() {
        super();
        _ProcessDataTracker_chunkStore.set(this, void 0);
        _ProcessDataTracker_writeable.set(this, void 0);
        _ProcessDataTracker_emitter.set(this, void 0);
        __classPrivateFieldSet(this, _ProcessDataTracker_chunkStore, {}, "f");
        __classPrivateFieldSet(this, _ProcessDataTracker_writeable, true, "f");
        __classPrivateFieldSet(this, _ProcessDataTracker_emitter, new stream_1.EventEmitter(), "f");
        __classPrivateFieldGet(this, _ProcessDataTracker_emitter, "f").on(Events.Block, () => __classPrivateFieldSet(this, _ProcessDataTracker_writeable, false, "f"));
        __classPrivateFieldGet(this, _ProcessDataTracker_emitter, "f").on(Events.Unblock, () => __classPrivateFieldSet(this, _ProcessDataTracker_writeable, true, "f"));
    }
    async onUnblock() {
        return new Promise((resolve) => __classPrivateFieldGet(this, _ProcessDataTracker_emitter, "f").on(Events.Unblock, resolve));
    }
    async getRowCount(chunkId) {
        return __classPrivateFieldGet(this, _ProcessDataTracker_chunkStore, "f")[chunkId]?.length ?? 0;
    }
    async store(storeContract) {
        if (!__classPrivateFieldGet(this, _ProcessDataTracker_chunkStore, "f")[storeContract.chunkId]) {
            __classPrivateFieldGet(this, _ProcessDataTracker_chunkStore, "f")[storeContract.chunkId] = [];
        }
        !__classPrivateFieldGet(this, _ProcessDataTracker_writeable, "f") && await this.onUnblock();
        __classPrivateFieldGet(this, _ProcessDataTracker_chunkStore, "f")[storeContract.chunkId].push(...storeContract.rows.map(row => {
            return {
                chunkId: storeContract.chunkId,
                table: storeContract.table,
                row
            };
        }));
    }
    async restore(chunkId) {
        __classPrivateFieldGet(this, _ProcessDataTracker_emitter, "f").emit(Events.Block);
        let rows = [];
        if (__classPrivateFieldGet(this, _ProcessDataTracker_chunkStore, "f")[chunkId]) {
            rows = __classPrivateFieldGet(this, _ProcessDataTracker_chunkStore, "f")[chunkId];
        }
        __classPrivateFieldGet(this, _ProcessDataTracker_emitter, "f").emit(Events.Unblock);
        return {
            chunkId,
            table: rows[0]?.table ?? 'not known',
            rows: rows.map(r => r.row)
        };
    }
}
exports.ProcessDataTracker = ProcessDataTracker;
_ProcessDataTracker_chunkStore = new WeakMap(), _ProcessDataTracker_writeable = new WeakMap(), _ProcessDataTracker_emitter = new WeakMap();
